﻿Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.Collections.Specialized
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Linq
Imports System.Text
'using System.Threading.Tasks;
Imports System.Windows.Forms
Imports Syncfusion.Grouping
Imports Syncfusion.Windows.Forms.Grid
Imports Syncfusion.Windows.Forms.Grid.Grouping
Imports Syncfusion.GridHelperClasses
Imports Syncfusion.Windows.Forms
Imports Syncfusion.Drawing
Imports System.Collections

Namespace WindowsFormsApplication21

	Partial Public Class Form1
		Inherits Form
		Private table As DataTable
		Public Sub New()

			InitializeComponent()

			Me.gridGroupingControl1.AllowProportionalColumnSizing = True
			Me.gridGroupingControl1.ShowGroupDropArea = True
			Me.gridGroupingControl1.DataSource = ReturnATable()
            'set cellvaluetype
            Me.gridGroupingControl1.TableDescriptor.Columns("Date").Appearance.AnyCell.CellValueType = GetType(DateTime)
            'set datatime format
            Me.gridGroupingControl1.TableDescriptor.Columns("Date").Appearance.AnyCell.Format = "MMM-yyyy"
            'event
            AddHandler gridGroupingControl1.QueryCellStyleInfo, AddressOf gridGroupingControl1_QueryCellStyleInfo
        End Sub
        Private Sub gridGroupingControl1_QueryCellStyleInfo(ByVal sender As Object, ByVal e As GridTableCellStyleInfoEventArgs)
            If e.TableCellIdentity.TableCellType = GridTableCellType.GroupCaptionCell AndAlso e.TableCellIdentity.GroupedColumn IsNot Nothing Then
                Dim captionRow As GridCaptionRow = TryCast(e.TableCellIdentity.DisplayElement, GridCaptionRow)
                Dim [date] As String = ""
                Dim dt As DateTime
                If e.Style.Text IsNot Nothing AndAlso DateTime.TryParse(e.Style.Text.Substring(e.Style.Text.IndexOf(":") + 1, 8), dt) Then

                    [date] = dt.ToString("MMM-yyyy")
                End If
                e.Style.CellValue = [String].Format("{0}: {1} Items.", [date], e.TableCellIdentity.DisplayElement.ParentGroup.GetChildCount())
            End If
        End Sub
		#Region "Datatable"
		Private Function ReturnATable() As DataTable
			table = New DataTable("People")

			'Adds two columns.
			table.Columns.Add(New DataColumn("FirstName"))
			table.Columns.Add(New DataColumn("LastName"))
			table.Columns.Add(New DataColumn("Age"))

			'Adds some rows.
			Dim dr As DataRow = table.NewRow()
			dr("FirstName") = "John"
			dr("LastName") = "Smith"
			dr("Age") = 29
			table.Rows.Add(dr)

			dr = table.NewRow()
			dr("FirstName") = "Sue"
			dr("LastName") = "Gaskins"
			dr("Age") = 32
			table.Rows.Add(dr)

			dr = table.NewRow()
			dr("FirstName") = "John"
			dr("LastName") = "Jacobs"
			dr("Age") = 56
			table.Rows.Add(dr)

			dr = table.NewRow()
			dr("FirstName") = "Sam"
			dr("LastName") = "Garfunkel"
			dr("Age") = 39
			table.Rows.Add(dr)

			dr = table.NewRow()
			dr("FirstName") = "George"
			dr("LastName") = "Shepherd"
			dr("Age") = 39
			table.Rows.Add(dr)

			dr = table.NewRow()
			dr("FirstName") = "Sue"
			dr("LastName") = "Gaskins"
			dr("Age") = 32
			table.Rows.Add(dr)

			dr = table.NewRow()
			dr("FirstName") = "John"
			dr("LastName") = "Jacobs"
			dr("Age") = 56
			table.Rows.Add(dr)

			dr = table.NewRow()
			dr("FirstName") = "Sam"
			dr("LastName") = "Garfunkel"
			dr("Age") = 39
			table.Rows.Add(dr)

			dr = table.NewRow()
			dr("FirstName") = "George"
			dr("LastName") = "Shepherd"
			dr("Age") = 39
			table.Rows.Add(dr)

			dr = table.NewRow()
			dr("FirstName") = "Sue"
			dr("LastName") = "Gaskins"
			dr("Age") = 32
			table.Rows.Add(dr)

			dr = table.NewRow()
			dr("FirstName") = "John"
			dr("LastName") = "Jacobs"
			dr("Age") = 56
			table.Rows.Add(dr)

			dr = table.NewRow()
			dr("FirstName") = "Sam"
			dr("LastName") = "Garfunkel"
			dr("Age") = 39
			table.Rows.Add(dr)

			dr = table.NewRow()
			dr("FirstName") = "George"
			dr("LastName") = "Shepherd"
			dr("Age") = 39
			table.Rows.Add(dr)

			dr = table.NewRow()
			dr("FirstName") = "Mary"
			dr("LastName") = "Tucker"
			dr("Age") = 42
			table.Rows.Add(dr)

			dr = table.NewRow()
			dr("FirstName") = "Becky"
			dr("LastName") = "Dunsford"
			dr("Age") = 33
			table.Rows.Add(dr)

			dr = table.NewRow()
			dr("FirstName") = "George"
			dr("LastName") = "Shepherd"
			dr("Age") = 38
			table.Rows.Add(dr)

			Return table
		End Function
		#End Region

	End Class

End Namespace
